/* 
   Generic Handle system
   Copyright (C) Elrond <elrond@samba-tng.org>  2003
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _HANDLE_H
#define _HANDLE_H


typedef struct _Handle Handle;

typedef void (* HandleDataFreeFn) (void *);


Handle *handle_new(Handle *parent);
void handle_set_parent(Handle *hnd, Handle *parent);
void handle_set_data(Handle *hnd, const char *name,
		     void *data, HandleDataFreeFn free_fn);
void *handle_get_data(const Handle *hnd, const char *name, int check_parents);
void handle_close(Handle *hnd);
void handle_set_name(Handle *hnd, const char *name);
const char *handle_get_name(const Handle *hnd);


#endif
