/* 
   Unix SMB/Netbios implementation.
   Copyright (C) Elrond                           2002
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _LIBSAMBA_H
#define _LIBSAMBA_H

#ifdef HAVE_GRP_H
#include <grp.h>
#else
struct group;  /* forward decl to calm compiler */
#endif
#ifdef HAVE_NETDB_H
#include <netdb.h>
#endif

/*
 * Some older systems seem not to have MAXHOSTNAMELEN defined.
 * This definition is here (instead of includes.h) because on Solaris
 * it is defined in <netdb.h>, included above.
 */
#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN 254
#endif

#include "talloc.h"
#include "interfaces.h"
#include "tdb.h"

/* Debugging stuff */
#include "debug.h"

#include "ntdomain.h"

#include "libsamba_proto.h"


extern pstring global_myname;
extern fstring global_myworkgroup;

#ifndef HAVE_ASPRINTF_DECL
int asprintf(char **,const char *, ...) PRINTF_ATTRIBUTE(2,3);
#endif
#ifndef HAVE_VASPRINTF_DECL
#include <stdarg.h>
int vasprintf(char **ptr, const char *format, va_list ap);
#endif
#ifndef HAVE_STRNLEN
size_t strnlen(const char *s, size_t n);
#endif
 
/*
 * note: slprintf is not quite snprintf.
 * the length arg is n-1 instead of n.
 */
#define slprintf snprintf
#endif
