#ifndef _SMBD_PROTO_H_
#define _SMBD_PROTO_H_
/* This file is automatically generated with "make proto". DO NOT EDIT */


/*The following definitions come from  locking/locking.c  */

BOOL is_locked(files_struct *fsp,connection_struct *conn,
	       SMB_BIG_UINT count,SMB_BIG_UINT offset,
	       enum brl_type lock_type);
BOOL do_lock(files_struct *fsp, uint16 lock_pid,
             SMB_BIG_UINT count,SMB_BIG_UINT offset,enum brl_type lock_type,
             int *eclass,uint32 *ecode);
NTSTATUS do_unlock(files_struct *fsp,connection_struct *conn, uint16 lock_pid,
               SMB_BIG_UINT count,SMB_BIG_UINT offset);
void locking_close_file(files_struct *fsp);
BOOL locking_init(int read_only);
BOOL locking_end(void);
BOOL lock_share_entry(connection_struct *conn,
		      SMB_DEV_T dev, SMB_INO_T inode);
void unlock_share_entry(connection_struct *conn,
			SMB_DEV_T dev, SMB_INO_T inode);
BOOL lock_share_entry_fsp(files_struct *fsp);
void unlock_share_entry_fsp(files_struct *fsp);
int get_share_modes(connection_struct *conn,
		    SMB_DEV_T dev, SMB_INO_T inode,
		    share_mode_entry **shares);
void del_share_mode(files_struct *fsp);
BOOL set_share_mode(files_struct *fsp, uint16 port, uint16 op_type);
BOOL remove_share_oplock(files_struct *fsp);
BOOL downgrade_share_oplock(files_struct *fsp);
BOOL modify_share_mode(files_struct *fsp, int new_mode, uint16 new_oplock);
BOOL modify_delete_flag( SMB_DEV_T dev, SMB_INO_T inode, BOOL delete_on_close);
int get_share_modes_fsp(files_struct *fsp, share_mode_entry **shares);

/*The following definitions come from  locking/posix.c  */

int fd_close_posix(struct connection_struct *conn, files_struct *fsp);
uint32 map_lock_offset(uint32 high, uint32 low);
BOOL is_posix_locked(files_struct *fsp, SMB_BIG_UINT u_offset, SMB_BIG_UINT u_count, enum brl_type lock_type);
BOOL set_posix_lock(files_struct *fsp, SMB_BIG_UINT u_offset, SMB_BIG_UINT u_count, enum brl_type lock_type);
BOOL release_posix_lock(files_struct *fsp, SMB_BIG_UINT u_offset, SMB_BIG_UINT u_count);
void posix_locking_close_file(files_struct *fsp);
BOOL posix_locking_init(int read_only);
BOOL posix_locking_end(void);

/*The following definitions come from  msdfs/msdfs.c  */

BOOL is_msdfs_link(connection_struct* conn, const char* path,
		   struct referral** reflistp, int* refcnt,
		   SMB_STRUCT_STAT *sbufp);
BOOL dfs_redirect(char* pathname, connection_struct* conn,
		  BOOL findfirst_flag);
int setup_dfs_referral(char* pathname, int max_referral_level, char** ppdata);

/*The following definitions come from  printing/printfsp.c  */

files_struct *print_fsp_open(connection_struct *conn, char *jobname,
			     uint32 access_mask, uint16 smbpid);
void print_fsp_end(files_struct *fsp);

/*The following definitions come from  smbd/auth_rhosts.c  */

BOOL check_hosts_equiv(char *user);

/*The following definitions come from  smbd/blocking.c  */

BOOL push_blocking_lock_request(files_struct *fsp, char *inbuf, int length, int lock_timeout, int lock_num);
void remove_pending_lock_requests_by_fid(files_struct *fsp);
void remove_pending_lock_requests_by_mid(int mid);
void process_blocking_lock_queue(time_t t);
BOOL blocking_locks_pending(void);

/*The following definitions come from  smbd/challenge.c  */

void generate_next_challenge(char *challenge);
BOOL set_challenge(unsigned char *challenge);
BOOL last_challenge(unsigned char *challenge);

/*The following definitions come from  smbd/close.c  */

int close_file(files_struct *fsp, BOOL normal_close);

/*The following definitions come from  smbd/conn.c  */

void conn_init(void);
int conn_num_open(void);
BOOL conn_snum_used(int snum);
connection_struct *conn_find(int cnum);
connection_struct *conn_new(void);
void conn_close_all(void);
BOOL conn_idle_all(time_t t, int deadtime);
void conn_free(connection_struct *conn);

/*The following definitions come from  smbd/connection.c  */

TDB_CONTEXT *conn_tdb_ctx(void);
BOOL yield_connection(connection_struct *conn,char *name,int max_connections);
BOOL claim_connection(connection_struct *conn,char *name,int max_connections,BOOL Clear);

/*The following definitions come from  smbd/dfree.c  */

SMB_BIG_UINT sys_disk_free(char *path, BOOL small_query,
                           SMB_BIG_UINT *bsize,SMB_BIG_UINT *dfree,SMB_BIG_UINT *dsize);

/*The following definitions come from  smbd/dir.c  */

BOOL dir_check_ftype(connection_struct *conn,int mode,SMB_STRUCT_STAT *st,int dirtype);
BOOL get_dir_entry(connection_struct *conn,char *mask,int dirtype,char *fname,
                   SMB_OFF_T *size,int *mode,time_t *date,BOOL check_descend);
void *OpenDir(connection_struct *conn, const char *_name, BOOL use_veto);
void CloseDir(void *p);
const char *ReadDirName(void *p);
BOOL SeekDir(void *p,int pos);
int TellDir(void *p);
void DirReload(connection_struct *conn, const char *_name);

/*The following definitions come from  smbd/dir_cache.c  */

void DirCacheAdd(const char *path, const char *name, const char *dname, int snum );
const char *DirCacheCheck(const char *path, const char *name, int snum );
void DirCacheFlush(int snum);

/*The following definitions come from  smbd/dosmode.c  */

mode_t unix_mode(connection_struct *conn,int dosmode,const char *fname);
int dos_mode(connection_struct *conn, const char *path, const SMB_STRUCT_STAT *sbuf);
int file_chmod(connection_struct *conn, const char *fname,
	       int dosmode, const SMB_STRUCT_STAT *st);
int file_utime(connection_struct *conn, const char *fname, struct utimbuf *times);
BOOL set_filetime(connection_struct *conn, const char *fname, time_t mtime);

/*The following definitions come from  smbd/dptr.c  */

void init_dptrs(void);
char *dptr_path(int key);
char *dptr_wcard(int key);
BOOL dptr_set_wcard(int key, char *wcard);
BOOL dptr_set_attr(int key, uint16 attr);
uint16 dptr_attr(int key);
void dptr_close(int *key);
void dptr_closecnum(connection_struct *conn);
void dptr_idlecnum(connection_struct *conn);
void dptr_closepath(char *path,uint16 spid);
int dptr_create(connection_struct *conn,char *path, BOOL old_handle, BOOL expect_close,uint16 spid);
BOOL dptr_fill(char *buf1,unsigned int key);
void *dptr_fetch(char *buf,int *num);
void *dptr_fetch_lanman2(int dptr_num);

/*The following definitions come from  smbd/error.c  */

int cached_error_packet(char *inbuf,char *outbuf,files_struct *fsp,
			const char *file,int line);
int unix_error_packet(char *inbuf,char *outbuf,int def_class,uint32 def_code,
		      const char *file, int line);
int error_packet(char *inbuf,char *outbuf,int error_class,uint32 error_code,
		 const char *file, int line);
int error_packet_nt(char *inbuf, char *outbuf, uint32 ntstatus,
		    const char *file, int line);
int error_packet_nt_and_dos(char *inbuf, char *outbuf,
			    NTSTATUS ntstatus,
			    int error_class, uint32 error_code,
			    const char *file, int line);
void smbd_error_put(char *inbuf, char *outbuf, NTSTATUS ntstatus,
		    const char *file, int line);
void smbd_error_put_both(char *inbuf, char *outbuf,
			 NTSTATUS ntstatus,
			 uchar error_class, uint16 error_code,
			 const char *file, int line);
void set_bad_path_error(int err, BOOL bad_path);

/*The following definitions come from  smbd/fileio.c  */

ssize_t read_file(files_struct *fsp,char *data,SMB_OFF_T pos,size_t n);
ssize_t write_file(files_struct *fsp, char *data, SMB_OFF_T pos, size_t n);
void set_filelen_write_cache(files_struct *fsp, SMB_OFF_T file_size);
ssize_t flush_write_cache(files_struct *fsp, enum flush_reason_enum reason);
void sync_file(connection_struct *conn, files_struct *fsp);

/*The following definitions come from  smbd/filename.c  */

BOOL unix_convert(char *name,connection_struct *conn,char *saved_last_component,
                  BOOL *bad_path, SMB_STRUCT_STAT *pst);
BOOL check_name(char *name,connection_struct *conn);
NTSTATUS path_check_syntax(const char *path);
NTSTATUS path_check_syntax_wo_lastcomp(const char *path);

/*The following definitions come from  smbd/files.c  */

files_struct *file_new(connection_struct *conn);
void file_close_conn(connection_struct *conn);
void file_close_pid(uint16 smbpid);
void file_init(void);
void file_close_user(int vuid);
files_struct *file_find_dit(SMB_DEV_T dev, SMB_INO_T inode, struct timeval *tval);
files_struct *file_find_fsp(files_struct *orig_fsp);
files_struct *file_find_di_first(SMB_DEV_T dev, SMB_INO_T inode);
files_struct *file_find_di_next(files_struct *start_fsp);
void fsp_set_pending_modtime(files_struct *fsp, time_t pmod);
void file_sync_all(connection_struct *conn);
void file_free(files_struct *fsp);
files_struct *file_fsp(char *buf, int where);
files_struct *fsp_find_conn_pkt(connection_struct *conn, char *buf, int where);
void file_chain_reset(void);
void file_chain_save(void);
void file_chain_restore(void);
void fsp_set_dos_name(files_struct *fsp, const char *name);
const char *file_dos_name(const files_struct *fsp);
const char *file_unix_name(const files_struct *fsp);
const char *file_debug_name(const files_struct *fsp);
const char *fsp_type_str(files_struct *fsp);
BOOL file_identical_thing(const files_struct *a, const files_struct *b);
int fsp_stat(files_struct *fsp, SMB_STRUCT_STAT *sbuf);
NTSTATUS fsp_set_delete_on_close(files_struct *fsp, BOOL delete_on_close);

/*The following definitions come from  smbd/ipc.c  */

void send_trans_reply(char *inbuf, char *outbuf,
		      const prs_struct *rdata,
		      const prs_struct *rparam,
		      uint16 *setup, int lsetup, int max_data_ret,
		      BOOL pipe_data_outstanding);
int reply_trans(connection_struct *conn, char *inbuf,char *outbuf, int size, int bufsize);

/*The following definitions come from  smbd/lanman.c  */

int api_reply(connection_struct * conn, uint16 vuid,
	      char *inbuf, char *outbuf,
	      char *data, char *params,
	      int tdscnt, int tpscnt, int mdrcnt, int mprcnt);

/*The following definitions come from  smbd/mangle.c  */

BOOL is_mangled(connection_struct *conn, const char *s);
BOOL is_8_3( char *fname, BOOL check_case );
void reset_mangled_cache( void );
const char *mangle_get_cached_real_name(const char *orig_name);
BOOL check_mangled_cache(char *str);
void mangle_name_83(connection_struct *conn, char *s);
BOOL name_map_mangle(connection_struct *conn, char *OutName, BOOL need83, BOOL cache83);

/*The following definitions come from  smbd/message.c  */

int reply_sends(connection_struct *conn,
		char *inbuf,char *outbuf, int dum_size, int dum_buffsize);
int reply_sendstrt(connection_struct *conn,
		   char *inbuf,char *outbuf, int dum_size, int dum_buffsize);
int reply_sendtxt(connection_struct *conn,
		  char *inbuf,char *outbuf, int dum_size, int dum_buffsize);
int reply_sendend(connection_struct *conn,
		  char *inbuf,char *outbuf, int dum_size, int dum_buffsize);

/*The following definitions come from  smbd/negprot.c  */

int reply_negprot(connection_struct *conn,
		  char *inbuf,char *outbuf, int dum_size,
		  int dum_buffsize);
void set_remote_arch(enum remote_arch_types type);
enum remote_arch_types get_remote_arch(void);

/*The following definitions come from  smbd/noquotas.c  */

BOOL disk_quotas(char *path,SMB_BIG_UINT *bsize,SMB_BIG_UINT *dfree,SMB_BIG_UINT *dsize);

/*The following definitions come from  smbd/notify.c  */

void remove_pending_change_notify_requests_by_fid(files_struct *fsp);
void remove_pending_change_notify_requests_by_mid(int mid);
void remove_pending_change_notify_requests_by_filename(files_struct *fsp);
BOOL process_pending_change_notify_queue(time_t t);
BOOL change_notifies_pending(void);
int call_nt_transact_notify_change(connection_struct *conn,
                                          char *inbuf, char *outbuf, int length,
                                          int bufsize,
                                          char **ppsetup,
                                          char **ppparams, char **ppdata);

/*The following definitions come from  smbd/nttrans.c  */

void fail_next_srvsvc_open(void);
BOOL should_fail_next_srvsvc_open(const char *pipename);
int reply_ntcreate_and_X(connection_struct *conn,
			 char *inbuf,char *outbuf,int length,int bufsize);
int reply_ntcancel(connection_struct *conn,
		   char *inbuf,char *outbuf,int length,int bufsize);
int reply_nttranss(connection_struct *conn,
		   char *inbuf,char *outbuf,int length,int bufsize);
int reply_nttrans(connection_struct *conn,
		  char *inbuf,char *outbuf,int length,int bufsize);

/*The following definitions come from  smbd/open.c  */

void fsp_set_open_time_basics(files_struct *fsp);
void fsp_open_finally(files_struct *fsp);
int fd_close(struct connection_struct *conn, files_struct *fsp);
files_struct *open_file_shared(connection_struct *conn,char *fname,int share_mode,int ofun,
		      mode_t mode,int oplock_request, int *Access,int *action,
		      uint32 access_mask, uint16 smbpid);
files_struct *open_file_stat(connection_struct *conn, const char *fname,
			     int smb_ofun, SMB_STRUCT_STAT *pst, int *action,
			     uint32 access_mask, uint16 smbpid);
files_struct *open_directory(connection_struct *conn, const char *fname,
			     int smb_ofun, int *action,
			     uint32 access_mask, uint16 smbpid);
files_struct *open_fsp_for_pipe(connection_struct *conn, const char *fname,
				pipes_struct *open_pipe,
				uint32 access_mask, uint16 smbpid);
BOOL check_file_sharing(connection_struct *conn, const char *fname, BOOL rename_op);
uint32 smbd_open_des_access(int share_mode);

/*The following definitions come from  smbd/oplock.c  */

int32 get_number_of_exclusive_open_oplocks(void);
BOOL oplock_message_waiting(fd_set *fds);
BOOL receive_local_message(char *buffer, int buffer_len, int timeout);
BOOL set_file_oplock(files_struct *fsp, int oplock_type);
void release_file_oplock(files_struct *fsp);
BOOL remove_oplock(files_struct *fsp, BOOL break_to_none);
int setup_oplock_select_set( fd_set *fds);
BOOL process_local_message(char *buffer, int buf_size);
BOOL oplock_break_level2(files_struct *fsp, BOOL local_request, int token);
BOOL request_oplock_break(share_mode_entry *share_entry,
                          SMB_DEV_T dev, SMB_INO_T inode);
BOOL attempt_close_oplocked_file(files_struct *fsp);
void release_level_2_oplocks_on_change(files_struct *fsp);
BOOL init_oplocks(void);

/*The following definitions come from  smbd/oplock_irix.c  */

struct kernel_oplocks *irix_init_kernel_oplocks(void);

/*The following definitions come from  smbd/oplock_linux.c  */

struct kernel_oplocks *linux_init_kernel_oplocks(void);

/*The following definitions come from  smbd/password.c  */

void add_session_user(const char *user);
uint32 password_ok(const char *orig_user, const char *domain,
		 const char *smb_apasswd, int smb_apasslen,
		 const char *smb_ntpasswd, int smb_ntpasslen,
		 struct passwd *pwd, NET_USER_INFO_3 * info3);
BOOL authorise_login(int snum, char *user, char *domain,
		     char *password, int pwlen,
		     BOOL *guest, BOOL *force, uint16 vuid);

/*The following definitions come from  smbd/pipe-proxy.c  */

void set_pipe_handle_offset(int max_open_files);
void reset_chain_p(void);
void init_rpc_pipe_hnd(void);
pipes_struct *open_rpc_pipe_p(connection_struct * conn,
			      const char *pipe_name, uint16 vuid);
BOOL wait_rpc_pipe_hnd_state(pipes_struct * p, uint16 priority);
BOOL set_rpc_pipe_hnd_state(pipes_struct * p, uint16 device_state);
BOOL close_rpc_pipe_hnd(pipes_struct * p);
pipes_struct *get_rpc_pipe_p(char *buf, int where);
pipes_struct *get_rpc_pipe(int pnum);
BOOL read_then_write_pipe(pipes_struct * p, char *data, int len,
		    char **rdata, int *rlen, BOOL *pipe_outstanding);
ssize_t write_to_pipe(pipes_struct * p, char *data, size_t n);
int read_from_pipe(pipes_struct * p, char *data, int max_len);

/*The following definitions come from  smbd/pipes.c  */

int reply_open_pipe_and_X(connection_struct * conn,
			  char *inbuf, char *outbuf, int length, int bufsize);
int reply_pipe_write(char *inbuf, char *outbuf, int length, int bufsize);
int reply_pipe_write_and_X(char *inbuf, char *outbuf, int length, int bufsize);
int reply_pipe_read_and_X(char *inbuf, char *outbuf, int length, int bufsize);
int reply_pipe_close(connection_struct * conn, char *inbuf, char *outbuf);

/*The following definitions come from  smbd/process.c  */

BOOL push_oplock_pending_smb_message(char *buf, int msg_len);
BOOL receive_next_smb(char *inbuf, int bufsize, int timeout);
void respond_to_all_remaining_local_messages(void);
void process_smb(char *inbuf, char *outbuf);
char *smb_fn_name(int type);
void construct_reply_common(char *inbuf,char *outbuf);
int chain_reply(char *inbuf,char *outbuf,int size,int bufsize);
void check_reload(int t);
void smbd_process(void);
char *conn_get_outbuffer(connection_struct *conn);

/*The following definitions come from  smbd/reply.c  */

void overflow_attack(int len);
int reply_special(char *inbuf, char *outbuf);
int reply_tcon(connection_struct * conn,
	       char *inbuf, char *outbuf, int dum_size, int dum_buffsize);
int reply_tcon_and_X(connection_struct * conn, char *inbuf, char *outbuf,
		     int length, int bufsize);
int reply_unknown(char *inbuf, char *outbuf);
int reply_ioctl(connection_struct * conn,
		char *inbuf, char *outbuf, int dum_size, int dum_buffsize);
int reply_chkpth(connection_struct * conn, char *inbuf, char *outbuf,
		 int dum_size, int dum_buffsize);
int reply_getatr(connection_struct * conn, char *inbuf, char *outbuf,
		 int dum_size, int dum_buffsize);
int reply_setatr(connection_struct * conn, char *inbuf, char *outbuf,
		 int dum_size, int dum_buffsize);
int reply_dskattr(connection_struct * conn, char *inbuf, char *outbuf,
		  int dum_size, int dum_buffsize);
int reply_search(connection_struct * conn, char *inbuf, char *outbuf,
		 int dum_size, int dum_buffsize);
int reply_fclose(connection_struct * conn, char *inbuf, char *outbuf,
		 int dum_size, int dum_buffsize);
int reply_open(connection_struct * conn, char *inbuf, char *outbuf,
	       int dum_size, int dum_buffsize);
int reply_open_and_X(connection_struct * conn, char *inbuf, char *outbuf,
		     int length, int bufsize);
int reply_ulogoffX(connection_struct * conn, char *inbuf, char *outbuf,
		   int length, int bufsize);
int reply_mknew(connection_struct * conn, char *inbuf, char *outbuf,
		int dum_size, int dum_buffsize);
int reply_ctemp(connection_struct * conn, char *inbuf, char *outbuf,
		int dum_size, int dum_buffsize);
int reply_unlink(connection_struct * conn, char *inbuf, char *outbuf,
		 int dum_size, int dum_buffsize);
int reply_readbraw(connection_struct * conn, char *inbuf, char *outbuf,
		   int dum_size, int dum_buffsize);
int reply_lockread(connection_struct * conn, char *inbuf, char *outbuf,
		   int length, int dum_buffsiz);
int reply_read(connection_struct * conn, char *inbuf, char *outbuf, int size,
	       int dum_buffsize);
int reply_read_and_X(connection_struct * conn, char *inbuf, char *outbuf,
		     int length, int bufsize);
int reply_writebraw(connection_struct * conn, char *inbuf, char *outbuf,
		    int size, int dum_buffsize);
int reply_writeunlock(connection_struct * conn, char *inbuf, char *outbuf,
		      int size, int dum_buffsize);
int reply_write(connection_struct * conn, char *inbuf, char *outbuf, int size,
		int dum_buffsize);
int reply_write_and_X(connection_struct * conn, char *inbuf, char *outbuf,
		      int length, int bufsize);
int reply_lseek(connection_struct * conn, char *inbuf, char *outbuf, int size,
		int dum_buffsize);
int reply_flush(connection_struct * conn, char *inbuf, char *outbuf, int size,
		int dum_buffsize);
int reply_exit(connection_struct * conn,
	       char *inbuf, char *outbuf, int dum_size, int dum_buffsize);
int reply_close(connection_struct * conn, char *inbuf, char *outbuf, int size,
		int dum_buffsize);
int reply_writeclose(connection_struct * conn,
		     char *inbuf, char *outbuf, int size, int dum_buffsize);
int reply_lock(connection_struct * conn,
	       char *inbuf, char *outbuf, int length, int dum_buffsize);
int reply_unlock(connection_struct * conn, char *inbuf, char *outbuf,
		 int size, int dum_buffsize);
int reply_tdis(connection_struct * conn,
	       char *inbuf, char *outbuf, int dum_size, int dum_buffsize);
int reply_echo(connection_struct * conn,
	       char *inbuf, char *outbuf, int dum_size, int dum_buffsize);
int reply_printopen(connection_struct * conn,
		    char *inbuf, char *outbuf, int dum_size, int dum_buffsize);
int reply_printclose(connection_struct * conn,
		     char *inbuf, char *outbuf, int dum_size,
		     int dum_buffsize);
int reply_printqueue(connection_struct * conn,
		     char *inbuf, char *outbuf, int dum_size,
		     int dum_buffsize);
int reply_printwrite(connection_struct * conn, char *inbuf, char *outbuf,
		     int dum_size, int dum_buffsize);
int reply_mkdir(connection_struct * conn, char *inbuf, char *outbuf,
		int dum_size, int dum_buffsize);
BOOL rmdir_internals(connection_struct *conn, const char *directory);
int reply_rmdir(connection_struct * conn, char *inbuf, char *outbuf,
		int dum_size, int dum_buffsize);
int rename_internals(connection_struct * conn,
		     char *inbuf, char *outbuf, char *name,
		     char *newname, BOOL replace_if_exists);
int reply_mv(connection_struct * conn, char *inbuf, char *outbuf,
	     int dum_size, int dum_buffsize);
int reply_copy(connection_struct * conn, char *inbuf, char *outbuf,
	       int dum_size, int dum_buffsize);
int reply_setdir(connection_struct * conn, char *inbuf, char *outbuf,
		 int dum_size, int dum_buffsize);
uint16 get_lock_pid( char *data, int data_offset, BOOL large_file_format);
SMB_BIG_UINT get_lock_count(char *data, int data_offset,
			    BOOL large_file_format);
SMB_BIG_UINT get_lock_offset(char *data, int data_offset,
			     BOOL large_file_format, BOOL *err);
int reply_lockingX(connection_struct * conn, char *inbuf, char *outbuf,
		   int length, int bufsize);
int reply_readbmpx(connection_struct * conn, char *inbuf, char *outbuf,
		   int length, int bufsize);
int reply_writebmpx(connection_struct * conn, char *inbuf, char *outbuf,
		    int size, int dum_buffsize);
int reply_writebs(connection_struct * conn, char *inbuf, char *outbuf,
		  int dum_size, int dum_buffsize);
int reply_setattrE(connection_struct * conn, char *inbuf, char *outbuf,
		   int size, int dum_buffsize);
int reply_getattrE(connection_struct * conn, char *inbuf, char *outbuf,
		   int size, int dum_buffsize);

/*The following definitions come from  smbd/server.c  */

int smbd_server_fd(void);
const char *client_name(void);
const char *client_addr(void);
void smbd_conn_send_smb(connection_struct *conn, char *buf);
void smbd_send_smb(char *buf);
BOOL reload_services(BOOL test);
void exit_server(char *reason);

/*The following definitions come from  smbd/service.c  */

BOOL become_service(connection_struct *conn,BOOL do_chdir);
int add_home_service(char *service, char *homedir);
int find_service(char *service);
connection_struct *make_connection(char *service,char *user,
				char *domain,
				char *password, int pwlen,
				char *dev,uint16 vuid, int *ecode);
void close_cnum(connection_struct *conn, uint16 vuid);
BOOL is_in_path(const char *name, name_compare_entry * namelist, BOOL case_sensitive);
void set_namearray(name_compare_entry ** ppname_array, char *namelist);
void free_namearray(name_compare_entry * name_array);

/*The following definitions come from  smbd/sesssetup.c  */

int reply_sesssetup_and_X(connection_struct * conn, char *inbuf, char *outbuf,
			  int length, int bufsize);

/*The following definitions come from  smbd/srvstr.c  */

int srvstr_push(void *base_ptr, void *dest, const char *src, int dest_len, int flags);
int srvstr_pull(void *base_ptr, char *dest, const void *src, int dest_len, int src_len,
		int flags);
int srvstr_pull_buf(void *inbuf, char *dest, const void *src, int dest_len, int flags);
void dos_to_unix(char *str, BOOL inplace);
const char *mangle_from_dos_to_unix(connection_struct *conn, const char *dosname,
				    BOOL need83, BOOL cache83);

/*The following definitions come from  smbd/statcache.c  */

void stat_cache_add( char *full_orig_name, char *orig_translated_path, BOOL case_sensitive);
BOOL stat_cache_lookup(connection_struct *conn, char *name, char *dirpath,
		       char **start, SMB_STRUCT_STAT *pst);
BOOL reset_stat_cache( void );

/*The following definitions come from  smbd/trans2.c  */

int reply_findclose(connection_struct *conn,
		    char *inbuf,char *outbuf,int length,int bufsize);
int reply_findnclose(connection_struct *conn,
		     char *inbuf,char *outbuf,int length,int bufsize);
int reply_transs2(connection_struct *conn,
		  char *inbuf,char *outbuf,int length,int bufsize);
int reply_trans2(connection_struct *conn,
		 char *inbuf,char *outbuf,int length,int bufsize);

/*The following definitions come from  smbd/uid.c  */

BOOL become_user(connection_struct *conn, uint16 vuid);
BOOL unbecome_user(void );

/*The following definitions come from  smbd/unix_acls.c  */

size_t get_nt_acl(files_struct *fsp, SEC_DESC **ppdesc);

/*The following definitions come from  smbd/utmp.c  */

void utmp_yield(pid_t pid, const connection_struct *conn);
void utmp_claim(const struct connections_data *crec, const connection_struct *conn);

/*The following definitions come from  smbd/vfs-wrap.c  */

void vfs_ops_setup_default(struct vfs_ops *ops);

/*The following definitions come from  smbd/vfs.c  */

BOOL vfs_init_default(connection_struct *conn);
BOOL vfs_directory_exist(connection_struct *conn, char *dname,
                         SMB_STRUCT_STAT *st);
BOOL vfs_file_exist(connection_struct *conn, const char *fname,SMB_STRUCT_STAT *sbuf);
ssize_t vfs_write_data(files_struct *fsp,char *buffer,size_t N);
SMB_OFF_T vfs_transfer_file(int in_fd, files_struct *in_fsp,
			    int out_fd, files_struct *out_fsp,
			    SMB_OFF_T n, char *header, int headlen, int align);
const char *vfs_readdirname(connection_struct *conn, void *p);
int vfs_ChDir(connection_struct *conn, const char *path);
char *vfs_GetWd(connection_struct *conn, char *path);
BOOL reduce_name(connection_struct *conn, char *s, const char *dir, BOOL widelinks);
void unix_clean_name(char *s);
void vfs_fill_ntinfo(connection_struct *conn, NTFileStatInfo *nti,
		     const char *dos_fname,
		     SMB_STRUCT_STAT *psbuf);
#endif /* _SMBD_PROTO_H_ */
