/* 
   Copyright (C) Elrond                       2002
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef TNG_READLINE_H
#define TNG_READLINE_H

#ifdef HAVE_READLINE
#  ifdef HAVE_READLINE_READLINE_H
#    include <readline/readline.h>
#    ifdef HAVE_READLINE_HISTORY_H
#      include <readline/history.h>
#      define HAVE_READLINE_HISTORY
#    endif
#  else
#    ifdef HAVE_READLINE_H
#      include <readline.h>
#      ifdef HAVE_HISTORY_H
#        include <history.h>
#        define HAVE_READLINE_HISTORY
#      endif
#    else
#      undef HAVE_READLINE
#    endif
#  endif
#  ifndef RL_STATE_NONE /* in <readline.h>, new in v4.2 */
#    define rl_completion_matches completion_matches
#    define rl_filename_completion_function filename_completion_function
#  endif
#endif


char *tng_micro_readline(const char *prompt);


#endif
