#include <stdio.h>
#include "winbind_auth.h"


static void out_struct(FILE * f, const char *buf1, int len, int per_line)
{
        const unsigned char  *buf = (const unsigned char  *)buf1;
        int i;

        if (len <= 0)
        {
                return;
        }

        fprintf(f, "{\n\t");
        for (i = 0; i < len;)
        {
                fprintf(f, "0x%02X", (int)buf[i]);
                i++;
                if (i != len)
                {
                        fprintf(f, ", ");
                }
                if (i % per_line == 0 && i != len)
                {
                        fprintf(f, "\n\t");
                }
        }
        fprintf(f, "\n};\n");
}


int main(int argc, char **argv)
{
	char *user = "test";
	char *pass = "test";
	char *domain = "WORKGROUP";

	size_t len = 0;
	void *blob = NULL;

	int status;

	unsigned char lm_hash[16];
	unsigned char nt_hash[16];
	char chal[8];
	char lm_pw[24];
	char nt_pw[24];

	nt_lm_owf_gen(pass, nt_hash, lm_hash);
	SMBOWFencrypt(nt_hash, chal, nt_pw);
	SMBOWFencrypt(lm_hash, chal, lm_pw);

	status = winbind_auth_request(user, domain, pass,
			&len, &blob);

	printf("status: %d\n", status);

	if (status == 0 && len > 0 && blob != NULL)
	{
		out_struct(stdout, blob, len, 16);
	}
	if (blob != NULL)
		free(blob);

	out_struct(stdout, chal, 8, 16);
	out_struct(stdout, lm_pw, 24, 16);
	out_struct(stdout, nt_pw, 24, 16);

	blob = NULL;
	status = winbind_auth_chal_request(user, domain, 
			chal, 8,
			lm_pw, 24,
			nt_pw, 24,
			&len, &blob);

	printf("status: %d\n", status);

	if (status == 0 && len > 0 && blob != NULL)
		out_struct(stdout, blob, len, 16);

	if (blob != NULL)
		free(blob);

	return 0;
}


