/* 
   samdb utility functions
   Copyright (C) Jeremy Allison 1996-1998
   Copyright (C) Luke Kenneth Casson Leighton 1996-1998
   Copyright (C) Elrond  2002,2004

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#include "includes.h"
#include "libsamba.h"
#include "samdb.h"


/*************************************************************
 Reset the password_last_set_time to the current time
 and do related stuff
 **************************************************************/
void sampwd_reset_pass_last_set_time(struct sam_passwd *sam)
{
	time_t now = time(NULL);
	unsigned int expire_delta;

	if (!sam)
		return;

	unix_to_nt_time(&sam->pass_last_set_time, now);

	if (!(sam->acct_ctrl & ACB_PWNOEXP)
	    && (expire_delta = lp_passwd_expire_time()))
	{
		unix_to_nt_time(&sam->pass_must_change_time,
				now + expire_delta * 86400);
	}
	else
	{
		/* Reset to -1 ;-) */
		init_nt_time(&sam->pass_must_change_time);
	}
}
